#!/usr/bin/env python

import sys
from qt import *

cb_width  = 32
cb_height = 32

TRUE = 1
FALSE = 0

cb_bits = \
   '\x00\x00\x00\x00\x00\x00\x00\x00\x00\xf8\x0f\x00'\
   '\x00\x06\x30\x00\x80\x01\xc0\x00\x40\x00\x00\x01'\
   '\x20\x00\x00\x02\x10\x00\x00\x04\x08\x3e\x3e\x08'\
   '\x08\x03\xe0\x08\xc4\x00\x00\x11\x04\x1e\x78\x10'\
   '\x02\x0c\x30\x20\x02\x40\x00\x20\x02\x40\x00\x20'\
   '\x02\x40\x00\x20\x02\x20\x04\x20\x02\x20\x04\x20'\
   '\x02\x10\x08\x20\x02\x08\x08\x20\x02\xf0\x07\x20'\
   '\x04\x00\x00\x10\x04\x00\x00\x10\x08\x00\xc0\x08'\
   '\x08\x3c\x30\x08\x10\xe6\x19\x04\x20\x00\x0f\x02'\
   '\x40\x00\x00\x01\x80\x01\xc0\x00\x00\x06\x30\x00'\
   '\x00\xf8\x0f\x00\x00\x00\x00\x00'

cm_width  = 32
cm_height = 32

cm_bits = \
   '\x00\x00\x00\x00\x00\xf8\x1f\x00\x00\xfe\x3f\x00'\
   '\x80\x07\xf0\x00\xc0\x01\xc0\x01\x60\x00\x00\x03'\
   '\x30\x00\x00\x06\x18\x00\x00\x0c\x0c\x3e\x3e\x18'\
   '\x0e\x03\xe0\x18\xc6\x00\x00\x31\x07\x1e\x78\x30'\
   '\x03\x0c\x30\x60\x03\x40\x00\x60\x03\x40\x00\x60'\
   '\x03\x40\x00\x60\x03\x20\x04\x60\x03\x20\x04\x60'\
   '\x03\x10\x08\x60\x03\x08\x08\x60\x03\xf0\x07\x60'\
   '\x06\x00\x00\x30\x06\x00\x00\x30\x0c\x00\xc0\x18'\
   '\x0c\x3c\x30\x18\x18\xe6\x19\x0c\x30\x00\x0f\x06'\
   '\x60\x00\x00\x03\xc0\x01\xc0\x01\x80\x07\xf0\x00'\
   '\x00\xfe\x3f\x00\x00\xf8\x0f\x00'

#
# The CursorView contains many labels with different cursors.
#

class CursorView(QWidget):
  def __init__(self):
    QWidget.__init__(self)

    list = {
				QCursor.ArrowCursor          :"arrowCursor" ,
				QCursor.UpArrowCursor        :"upArrowCursor" ,
				QCursor.CrossCursor          :"crossCursor" ,
				QCursor.WaitCursor           :"waitCursor" ,
				QCursor.IbeamCursor          :"ibeamCursor" ,
				QCursor.SizeVerCursor        :"sizeVerCursor" ,
				QCursor.SizeHorCursor        :"sizeHorCursor" ,
				QCursor.SizeBDiagCursor      :"sizeBDiagCursor" ,
				QCursor.SizeFDiagCursor      :"sizeFDiagCursor" ,
				QCursor.SizeAllCursor        :"sizeAllCursor" ,
				QCursor.BlankCursor          :"blankCursor" ,
				QCursor.SplitVCursor         :"splitVCursor" ,
				QCursor.SplitHCursor         :"splitHCursor" ,
				QCursor.PointingHandCursor   :"pointingHandCursor" ,
				QCursor.ForbiddenCursor      :"forbiddenCursor" ,
				QCursor.WhatsThisCursor      :"whatsThisCursor"
    }

    self.setCaption( "CursorView" ) # set window caption

    grid = QGridLayout( self, 5, 4, 20 )

    x = 0
    y = 0

    for k in list.keys():
			
      label = QLabel( self )
      label.setCursor( QCursor(k) )
      label.setText( list[k] )
      label.setAlignment( Qt.AlignCenter )
      label.setMargin( 10 )
      label.setFrameStyle( QFrame.Box | QFrame.Raised )
			
      grid.addWidget( label, x, y )

      x = x+1
      if x>=4:
        x = 0
        y = y+1

    cb = QBitmap( cb_width, cb_height, cb_bits, TRUE )
    cm = QBitmap( cm_width, cm_height, cm_bits, TRUE )
    custom = QCursor( cb, cm )             # create bitmap cursor

    label = QLabel( self )                 # create the big label
    label.setCursor( custom );
    label.setText( "Custom bitmap cursor" )
    label.setAlignment( Qt.AlignCenter )
    label.setMargin( 10 )
    label.setFrameStyle( QFrame.Box | QFrame.Sunken )
		
    grid.addMultiCellWidget( label, 4, 4, 0, 3 )

a = QApplication( sys.argv ) # application object
v = CursorView()             # cursor view
a.setMainWidget( v )
v.setCaption("PyQt Example - Cursors")
v.show()
a.exec_loop()