#!/usr/bin/env python

import sys
from qt import *
from random import random

TRUE  = 1
FALSE = 0
numColors = 120

class Forever(QWidget):
    def __init__(self,parent=None,name=None):
        QWidget.__init__(self,parent,name)
	self.colors = []
	for a in range(numColors):
	    self.colors.append(QColor(random()*255,random()*255,random()*255))
	self.rectangles = 0
	self.startTimer(0)
	self.counter = QTimer(self)
	self.connect(self.counter,SIGNAL('timeout()'),self.updateCaption)
	self.counter.start(1000)

    def updateCaption(self):
	s = 'PyQt Example - Forever - ' + str(self.rectangles) + ' rectangles/second'
	self.rectangles = 0
	self.setCaption(s)

    def paintEvent(self,e):
	paint = QPainter(self)
	w = self.width()
	h = self.height()
	if (w<=0 or h<=0): return
	paint.setPen(Qt.NoPen)
	paint.setBrush(QBrush(self.colors[int(random()*numColors)]))

	p1 = QPoint(int(random()*w),int(random()*h))
	p2 = QPoint(int(random()*w),int(random()*h))

	r = QRect(p1,p2)
	paint.drawRect(r)

    def timerEvent(self,e):
	for i in range(100):
	    self.repaint(FALSE)
	    self.rectangles = self.rectangles + 1


## main program
a = QApplication(sys.argv)
always = Forever()
a.setMainWidget(always)
always.setCaption("PyQt Example - Forever")
always.show()

a.exec_loop()


