#!/usr/bin/env python

import sys, string
from qt import *

TRUE  = 1
FALSE = 0

class ExampleWidget(QWidget):
    def __init__( self ):
        QWidget.__init__(self,None,None)
	
	topLayout = QVBoxLayout(self,5)

	menubar = QMenuBar(self)
	menubar.setSeparator(QMenuBar.InWindowsStyle)
	popup = QPopupMenu(self)
	popup.insertItem('&Quit',qApp,SLOT('quit()'))
	menubar.insertItem('&File',popup)

	topLayout.setMenuBar(menubar)

	buttons = QHBoxLayout(topLayout)

	for i in range(1,5):
	    but = QPushButton(self)
	    but.setText('Button' + str(i))
	    buttons.addWidget(but,10)

	buttons2 = QHBoxLayout(topLayout)
	
	but = QPushButton('Button five',self)
	buttons2.addWidget(but)

	but = QPushButton('Button 6',self)
	buttons2.addWidget(but)

	buttons2.addStretch(10)

	bigWidget = QMultiLineEdit(self)
	bigWidget.setText('This widget will get all the remaining space')
	bigWidget.setFrameStyle(QFrame.Panel|QFrame.Plain)

	topLayout.addWidget(bigWidget)

	numRows = 3
	labelCol = 0
	linedCol = 1
	multiCol = 2

	grid = QGridLayout(topLayout,0,0,10)

	for row in range(numRows):
	    ed = QLineEdit(self)
	    grid.addWidget(ed,row,linedCol)
	    label = QLabel(ed,'Line &' + str(row + 1),self)
	    grid.addWidget(label,row,labelCol)

	med = QMultiLineEdit(self)
	grid.addMultiCellWidget(med,0,-1,multiCol,multiCol)

	grid.setColStretch(linedCol,10)
	grid.setColStretch(multiCol,20)

	sb = QLabel(self)
	sb.setText("Let's pretend this is a status bar")
	sb.setFrameStyle(QFrame.Panel|QFrame.Sunken)

	sb.setFixedHeight(sb.sizeHint().height())

	sb.setAlignment(QLabel.AlignVCenter|QLabel.AlignLeft)
	topLayout.addWidget(sb)

	topLayout.activate()

## main program
a = QApplication( sys.argv )

f = ExampleWidget()
f.setCaption('PyQt Example - Caption')
a.setMainWidget(f)
f.show()

a.exec_loop()
