#!/usr/bin/env python

import sys, string
from qt import *

TRUE  = 1
FALSE = 0

class ListBoxDemo(QWidget):
    def __init__( self ):
        QWidget.__init__(self,None,None)

	g = QGridLayout(self,2,2,6)

	g.addWidget(QLabel('<b>Configuration</b>',self),0,0)
	g.addWidget(QLabel('<b>Result:</b>',self),0,1)

	self.l = QListBox(self)
	g.addWidget(self.l,1,1)
	self.l.setFocusPolicy(QWidget.StrongFocus)

	v = QVBoxLayout()
	g.addLayout(v,1,0)

	self.bg = QButtonGroup()
	self.bg.setExclusive(TRUE)

	b1 = QRadioButton('Fixed number of columns,\n'
			 'as many rows as needed.',self)
	self.bg.insert(b1)
	v.addWidget(b1)
	b1.setChecked(TRUE)
	self.connect(b1,SIGNAL('clicked()'),self.setNumCols)
	h = QHBoxLayout()
	v.addLayout(h)
	h.addSpacing(30)
	h.addSpacing(100)
	h.addWidget(QLabel('Columns:',self))
	self.columns = QSpinBox(self)
	h.addWidget(self.columns)

	v.addSpacing(12)

	b2 = QRadioButton('As many columns as fit on-screen,\n'
                          'as many rows as needed.',self)
	self.bg.insert(b2)
	v.addWidget(b2)
	self.connect(b2,SIGNAL('clicked()'),self.setColsByWidth)

	v.addSpacing(12)

	b3 = QRadioButton('Fixed number of rows,\n'
                         'as many columns as needed.',self)
	self.bg.insert(b3)
	v.addWidget(b3)
	self.connect(b3,SIGNAL('clicked()'),self.setNumRows)
	h = QHBoxLayout()
	v.addLayout(h)
	h.addSpacing(30)
	h.addSpacing(100)

	h.addWidget(QLabel('Rows:',self))
	self.rows = QSpinBox(self)
	self.rows.setEnabled(FALSE)
	h.addWidget(self.rows)


	v.addSpacing(12)

	b4 = QRadioButton('As many rows as fit on-screen,\n'
                          'as many columns as needed.',self)
	self.bg.insert(b4)
	v.addWidget(b4)
	self.connect(b4,SIGNAL('clicked()'),self.setRowsByHeight)

	v.addSpacing(12)
	
	cb1 = QCheckBox('variable-height rows',self)
	cb1.setChecked(TRUE)
	self.connect(cb1,SIGNAL('toggled(bool)'),self.setVariableHeight)
	v.addWidget(cb1)
	v.addSpacing(6)

	cb2 = QCheckBox('variable-width columns',self)
	self.connect(cb2,SIGNAL('toggled(bool)'),self.setVariableWidth)
	v.addWidget(cb2)

	cb3 = QCheckBox('Extended-Selection',self)
	self.connect(cb3,SIGNAL('toggled(bool)'),self.setMultiSelection)
	v.addWidget(cb3)

	pb1 = QPushButton('Sort ascending',self)
	self.connect(pb1,SIGNAL('clicked()'),self.sortAscending)
	v.addWidget(pb1)

	pb2 = QPushButton('Sort descending',self)
	self.connect(pb2,SIGNAL('clicked()'),self.sortDescending)
	v.addWidget(pb2)

	v.addStretch(100)

	for i in range(1,2561):
	    self.l.insertItem('Item' + str(i))
	self.columns.setRange(1,256)
	self.columns.setValue(1)
	self.rows.setRange(1,256)
	self.rows.setValue(256)

	self.connect(self.columns,SIGNAL('valueChanged(int)'),self.setNumCols)
	self.connect(self.rows,SIGNAL('valueChanged(int)'),self.setNumRows)

    def setNumCols(self):
	self.columns.setEnabled(TRUE)
	self.rows.setEnabled(FALSE)
	self.l.setColumnMode(self.columns.value())

    def setColsByWidth(self):
	self.columns.setEnabled(FALSE)
	self.rows.setEnabled(FALSE)
	self.l.setColumnMode(QListBox.FitToWidth)

    def setNumRows(self):
	self.columns.setEnabled(FALSE)
	self.rows.setEnabled(TRUE)
	self.l.setRowMode(self.rows.value())

    def setRowsByHeight(self):
	self.columns.setEnabled(FALSE)
	self.rows.setEnabled(FALSE)
	self.l.setRowMode(QListBox.FitToHeight)

    def setVariableHeight(self,bool):
	self.l.setVariableHeight(bool)

    def setVariableWidth(self,bool):
	self.l.setVariableWidth(bool)

    def setMultiSelection(self,bool):
	self.l.clearSelection()
	if bool:
	   self.l.setSelectionMode(QListBox.Extended)
	else:
	   self.l.setSelectionMode(QListBox.Single)

    def sortAscending(self):
	self.l.sort(TRUE)

    def sortDescending(self):
	self.l.sort(FALSE)


## main program
a = QApplication( sys.argv )

t = ListBoxDemo()
t.setCaption('PyQt Example - Listbox')
a.setMainWidget(t)
t.show()

a.exec_loop()
