#!/usr/bin/env python

import sys
from qt import *

TRUE  = 1
FALSE = 0

class MyListBoxItem( QListBoxItem ):
    def __init__(self):
	QListBoxItem.__init__(self)
	self.setCustomHighlighting(TRUE)

    def paint(self,painter):
	if self.listBox() and self.listBox().viewport() == painter.device(): in_list_box = TRUE
	else: in_list_box = FALSE
	r = QRect(0,0,self.width(self),self.height(self))
	if (in_list_box and self.isSelected()):
	   painter.eraseRect(r)
	painter.fillRect(5,5,self.width(self) - 10,self.height(self) - 10, Qt.red)
	if (in_list_box and self.isCurent()):
	   self.listBox().style().drawPrimitive(QStyle.PE_FocusRect,painter,r,self.listBox().colorGroup())

    def width(self):
	return 100

    def height(self):
	return 16


class ListBoxCombo( QVBox ):
    def __init__(self,parent=None,name=None):
	QVBox.__init__(self,parent,name)

	self.setMargin(5)
	self.setSpacing(5)
	
	row1 = QHBox(self)
	row1.setSpacing(5)

	self.lb1 = QListBox(row1)
	self.lb1.setSelectionMode(QListBox.Multi)
	self.lb1.insertItem(QPixmap('qtlogo.png'))

	k = -1

#!!!!!!!!!!!!!!!!!!!!!!!!!
#    i = 100!!!

	for i in range(10):
	    k = k+1
	    tstr = 'Listbox Item ' + str(i)
	    if k == 4 or k == 0: 
	       k = 0
	       self.lb1.insertItem(QPixmap('fileopen.xpm'),tstr)
	    else:
	       self.lb1.insertItem(tstr)

	arrow1 = QPushButton('->',row1)
	self.connect(arrow1,SIGNAL('clicked()'),self.slotLeft2Right)

	self.lb2 = QListBox(row1)

	row2 = QHBox(self)
	row2.setSpacing(5)

	box1 = QVBox(row2)
	box1.setSpacing(5)

	cb1 = QComboBox(FALSE,box1)
	self.label1 = QLabel('Curent Item: Combobox Item 0', box1)
	self.label1.setMaximumHeight(self.label1.sizeHint().height()*2)
	self.label1.setFrameStyle(QFrame.Panel|QFrame.Sunken)

	k = -1
	for i in range(50):
	    k = k+1
	    tstr = 'Combobox Item ' + str(i)
	    if k != 9 or k == 0: 
	       k = 0
	       cb1.insertItem(tstr)

#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#	    else:
#	       cb1.ListBox().insertItem(new MyListBoxItem())

	box2 = QVBox(row2)
	box2.setSpacing(5)

	cb2 = QComboBox(FALSE,box2)
	self.label2 = QLabel('Curent Item: Combobox Item 0', box2)
	self.label2.setMaximumHeight(self.label2.sizeHint().height()*2)
	self.label2.setFrameStyle(QFrame.Panel|QFrame.Sunken)

	k = -1
	for i in range(50):
	    k = k+1
	    tstr = 'Combobox Item ' + str(i)
	    if k == 4 or k == 0: 
	       k = 0
	       cb2.insertItem(QPixmap('fileopen.xpm'),tstr)
	    else:
	       cb2.insertItem(tstr)

	self.connect(cb1,SIGNAL('activated(int)'),self.slotCombo1Activated)
	self.connect(cb2,SIGNAL('activated(int)'),self.slotCombo2Activated)

    def slotCombo1Activated(self,int):
	self.label1.setText('Current Item: Combobox Item ' + str(int))

    def slotCombo2Activated(self,int):
	self.label2.setText('Current Item: Combobox Item ' + str(int))

    def slotLeft2Right(self):
	for i in range(self.lb1.count()):
	    item = QListBoxItem()
	    item = self.lb1.item(i)
	    print i
	    if item.isSelected():
		print "item isSelected"
		print str(item.pixmap())
		if ((item.pixmap() != None) and (item.text().isEmpty() != None)):
		   print "if 1"
		   self.lb2.insertItem(item.pixmap(),item.text())
		elif (item.pixmap() == None):
		   self.lb2.insertItem(item.text())
		elif item.text().isEmpty():
		   print "if 3"
		   self.lb2.insertItem(item.pixmap())


## main program
a = QApplication(sys.argv)

listboxcombo = ListBoxCombo()
listboxcombo.resize(400,270)
listboxcombo.setCaption("PyQT Example - Listboxes and Comboboxes")
a.setMainWidget(listboxcombo)
listboxcombo.show()

a.exec_loop()

