#!/usr/bin/env python

import sys, string
from qt import *

TRUE  = 1
FALSE = 0
fileopen = [
'    16    13        5            1',
'. c #040404',
'# c #808304',
'a c None',
'b c #f3f704',
'c c #f3f7f3',
'aaaaaaaaa...aaaa',
'aaaaaaaa.aaa.a.a',
'aaaaaaaaaaaaa..a',
'a...aaaaaaaa...a',
'.bcb.......aaaaa',
'.cbcbcbcbc.aaaaa',
'.bcbcbcbcb.aaaaa',
'.cbcb...........',
'.bcb.#########.a',
'.cb.#########.aa',
'.b.#########.aaa',
'..#########.aaaa',
'...........aaaaa'
]

filesave = [
'    14    14        4            1',
'. c #040404',
'# c #808304',
'a c #bfc2bf',
'b c None',
'..............',
'.#.aaaaaaaa.a.',
'.#.aaaaaaaa...',
'.#.aaaaaaaa.#.',
'.#.aaaaaaaa.#.',
'.#.aaaaaaaa.#.',
'.#.aaaaaaaa.#.',
'.##........##.',
'.############.',
'.##.........#.',
'.##......aa.#.',
'.##......aa.#.',
'.##......aa.#.',
'b.............'
]

filenew = [
'16 16 3 1',
'       c None',
'.      c #000000000000',
'X      c #FFFFFFFFFFFF',
'                ',
'   ......       ',
'   .XXX.X.      ',
'   .XXX.XX.     ',
'   .XXX.XXX.    ',
'   .XXX.....    ',
'   .XXXXXXX.    ',
'   .XXXXXXX.    ',
'   .XXXXXXX.    ',
'   .XXXXXXX.    ',
'   .XXXXXXX.    ',
'   .XXXXXXX.    ',
'   .XXXXXXX.    ',
'   .........    ',
'                ',
'                '
]

class MenuExample(QMainWindow):
    def __init__( self ):
        QMainWindow.__init__( self, None, 'example using menus' )

	self.prints = QPopupMenu(self)
        self.prints.insertTearOffHandle()
	self.prints.insertItem('&Print to printer', self.printer)
	self.prints.insertItem('Print to &file', self.files)
	self.prints.insertItem('Print to fa&x', self.fax)
	self.prints.insertSeparator()
	self.prints.insertItem('Printer &Setup', self.printerSetup)

        self.file = QPopupMenu( self )

        openIcon = QIconSet( QPixmap( fileopen ) )
        self.file.insertItem( openIcon, '&Open', self.open, Qt.CTRL + Qt.Key_O )
        newIcon = QIconSet( QPixmap( filenew ) )
        self.file.insertItem( newIcon,'&New', self.news, Qt.CTRL + Qt.Key_N )
        saveIcon = QIconSet( QPixmap( filesave ) )
        self.file.insertItem( saveIcon, '&Save', self.save, Qt.CTRL + Qt.Key_S )
        self.file.insertItem('&Close', self.closeDoc, Qt.CTRL+Qt.Key_W)
        self.file.insertSeparator()
        self.file.insertItem( '&Print', self.prints, Qt.CTRL + Qt.Key_P )
        self.file.insertSeparator()
        self.file.insertItem( 'E&xit', qApp, SLOT( 'quit()' ), Qt.CTRL + Qt.Key_Q )

        self.edit = QPopupMenu( self )

        undoID = self.edit.insertItem( '&Undo', self.undo )
        redoID = self.edit.insertItem( '&Redo', self.redo )
	self.edit.setItemEnabled(undoID,FALSE)
	self.edit.setItemEnabled(redoID,FALSE)

        self.options = QPopupMenu( self )

        self.options.insertTearOffHandle()
        self.options.insertItem( '&Normal Font', self.normal )
        self.options.insertSeparator()

	self.options.polish()
	f = QFont()
	f = self.options.font()
	f.setBold(TRUE)

        self.boldID = self.options.insertItem( 'Bold', self.bold, Qt.CTRL + Qt.Key_B )
        self.underlineID = self.options.insertItem( 'Underline', self.underline, Qt.CTRL + Qt.Key_U )

	self.isBold = FALSE
	self.isUnderline = FALSE
	self.options.setCheckable(TRUE)

        self.help = QPopupMenu( self )

        self.help.insertItem( '&About', self.about )
        self.help.insertItem( '&About PyQt', self.aboutPyQt )


        self.menuBar().insertItem( '&File', self.file )
        self.menuBar().insertItem( '&Edit', self.edit )
        self.menuBar().insertItem( '&Options', self.options )
	self.menuBar().insertSeparator()
        self.menuBar().insertItem( '&Help', self.help )
	self.menuBar().setSeparator(QMenuBar.InWindowsStyle)

	
	msg = QLabel(self)
	msg.setText("A context menu is available.\n Invoke it by right-clicking or by pressing the context button.")
	msg.setGeometry(0,150,400,200)
	msg.setAlignment(QLabel.AlignCenter)

	self.label = QLabel(self)
	self.label.setGeometry(40,100,320,30)
	self.label.setFrameStyle(QFrame.Box|QFrame.Raised)
	self.label.setLineWidth(1)
	self.label.setAlignment(QLabel.AlignCenter)

	self.connect(self,PYSIGNAL('explain(str)'),self.label,SLOT('setText(str)'))



    def contextMenuEvent(self,ev):
	self.contextMenu = QPopupMenu(self)
	self.caption = QLabel("<font color=darkblue><u><b>Context Menu</b></u></font>", self)
	self.caption.setAlignment(QLabel.AlignCenter)
	self.contextMenu.insertItem(self.caption)
	self.contextMenu.insertItem('&New', self.news, Qt.CTRL + Qt.Key_N)
	self.contextMenu.insertItem('&Open...', self.open, Qt.CTRL + Qt.Key_O)
	self.contextMenu.insertItem('&Save', self.save, Qt.CTRL + Qt.Key_S)
	self.submenu = QPopupMenu(self)
	self.submenu.insertItem('&Print to printer', self.printer)
	self.submenu.insertItem('Print to &file', self.files)
	self.submenu.insertItem('Print to fa&x', self.fax)
	self.contextMenu.insertItem('&Print',self.submenu)
	self.contextMenu.exec_loop(QCursor.pos())


    def open(self):
	self.emit(PYSIGNAL('explain(str)'),("File/Open selected",))

    def news(self):
	self.emit(PYSIGNAL('explain(str)'),("File/New selected",))

    def save(self):
	self.emit(PYSIGNAL('explain(str)'),("File/Save selected",))

    def closeDoc(self):
	self.emit(PYSIGNAL('explain(str)'),("File/Close selected",))

    def undo(self):
	self.emit(PYSIGNAL('explain(str)'),("Edit/Undo selected",))

    def redo(self):
	self.emit(PYSIGNAL('explain(str)'),("Edit/Redo selected",))

    def normal(self):
	self.isBold = FALSE
	self.isUnderline = FALSE
	font = QFont()
	self.label.setFont(font)

	self.menuBar().setItemChecked(self.boldID,self.isBold)
	self.menuBar().setItemChecked(self.underlineID,self.isUnderline)	
	self.emit(PYSIGNAL('explain(str)'),("Options/Normal selected",))

    def bold(self):
	if self.isBold: 
	   self.isBold = FALSE
	else:
	   self.isBold = TRUE

	self.font = QFont()
	self.font.setBold(self.isBold)
	self.font.setUnderline(self.isUnderline)
	self.label.setFont(self.font)

	self.menuBar().setItemChecked(self.boldID,self.isBold)
	self.emit(PYSIGNAL('explain(str)'),("Options/Bold selected",))

    def underline(self):
	if self.isUnderline: 
	   self.isUnderline = FALSE
	else:
	   self.isUnderline = TRUE

	self.font = QFont()
	self.font.setBold(self.isBold)
	self.font.setUnderline(self.isUnderline)
	self.label.setFont(self.font)

	self.menuBar().setItemChecked(self.underlineID,self.isUnderline)
	self.emit(PYSIGNAL('explain(str)'),("Options/Underline selected",))


    def about(self):
	about = QMessageBox.information(self,"PyQt Menu Examples","This example demonstrates simple use of PyQt menus.\nYou can cut and paste lines from it to your own\nprograms.") 

    def aboutPyQt(self):
	about = QMessageBox.aboutQt(self,"PyQt Menu Examples") 

    def printer(self):
	self.emit(PYSIGNAL('explain(str)'),("File/Print/Print To Printer selected",))

    def files(self):
	self.emit(PYSIGNAL('explain(str)'),("File/Print/Print To File selected",))

    def fax(self):
	self.emit(PYSIGNAL('explain(str)'),("File/Print/Print To Fax selected",))

    def printerSetup(self):
	self.emit(PYSIGNAL('explain(str)'),("File/Print/Printer Setup selected",))


a = QApplication( sys.argv )

mm = MenuExample()
mm.setCaption( 'Using menus' )
a.setMainWidget( mm )
mm.resize(401,301)
mm.show()

a.exec_loop()
