#!/usr/bin/env python

import sys
from qt import *

TRUE  = 1
FALSE = 0

class FancyPopup(QLabel):
    def __init__(self,parent=None,name=None):
	self.popupParent = QWidget()
	QLabel.__init__(self,parent,name,QWidget.WType_Popup)
	self.setFrameStyle(QFrame.WinPanel|QFrame.Raised)
	self.setAlignment(QLabel.AlignCenter)
	self.resize(150,100)
	self.moves = 0
	self.setMouseTracking(TRUE)

    def mouseMoveEvent(self,e):
	self.moves = self.moves + 1
	s = QString()
	s = str(e.pos().x()) + '/' + str(e.pos().y())
	if e.state()&QMouseEvent.LeftButton:
	   s = s + '(down)'
	self.setText(s)

    def mouseReleaseEvent(self,e):
	if rect().contains(e.pos() or self.moves > 5):
	   close()

    def closeEvent(self,e):
	e.accept()
	self.moves = 0
	if self.popupParent == 0:
	   return

	me = QMouseEvent( QEvent.MouseButtonRelease, QPoint(0,0), QPoint(0,0), QMouseEvent.LeftButton, QMouseEvent.NoButton);
	QApplication.sendEvent(self.popupParent, me)

    def popup(self,parent):
	self.popupParent = parent
	self.setText('Move the mouse!')
	if self.popupParent != 0:
	   self.move( self.popupParent.mapToGlobal(self.popupParent.rect().bottomLeft()))
	self.show()


class Frame(QFrame):
    def __init__(self,parent=None,name=None):
	QFrame.__init__(self,parent,name)
	self.button1 = QPushButton('Simple Popup',self)
	self.connect(self.button1,SIGNAL('clicked()'),self.button1Clicked)
	self.button2 = QPushButton('Fancy Popup',self)
	self.connect(self.button2,SIGNAL('clicked()'),self.button2Clicked)

	l = QHBoxLayout(self)
	self.button1.setMaximumSize(self.button1.sizeHint())
	self.button2.setMaximumSize(self.button2.sizeHint())
	l.addWidget(self.button1)
	l.addWidget(self.button2)
	l.activate()

	self.resize(270,70)

	self.popup1 = QFrame(self,None,Qt.WType_Popup)
	self.popup1.setFrameStyle(QFrame.WinPanel|QFrame.Raised)
	self.popup1.resize(150,100)
	tmpE = QLineEdit(self.popup1)
	self.connect(tmpE,SIGNAL('returnPressed()'),self.popup1,SLOT('hide()'))
	tmpE.setGeometry(10,10,130,30)
	tmpE.setFocus()
	tmpB = QPushButton('Click me!',self.popup1)
	self.connect(tmpB,SIGNAL('clicked()'),self.popup1,SLOT('close()'))
	tmpB.setGeometry(10,50,130,30)

	self.popup2 = FancyPopup()

    def button1Clicked(self):
	self.popup1.move( QWidget.mapToGlobal(self,self.button1.geometry().bottomLeft()))
	self.popup1.show()

    def button2Clicked(self):
	self.popup2.popup(self.button2)

## main program
a = QApplication(sys.argv)

frame = Frame()
frame.setCaption("PyQT Example - Range Custom Popups")
a.setMainWidget(frame)
frame.show()

a.exec_loop()

