#!/usr/bin/env python

import sys
from qt import *

TRUE  = 1
FALSE = 0

class UicManager(QVBox):
    def __init__(self):
        QVBox.__init__(self)
	self.output = QTextView(self)
	self.quitButton = QPushButton('Quit',self)
	self.connect(self.quitButton,SIGNAL('clicked()'),qApp,SLOT('quit()'))
	self.resize(500,500)

	self.proc = QProcess(self)

	self.proc.addArgument('uic')
	self.proc.addArgument('-tr')
	self.proc.addArgument('i18n')
	self.proc.addArgument('small_dialog.ui')

	self.connect(self.proc,SIGNAL('readyReadStdout()'),self.readFromStdout)
	self.connect(self.proc,SIGNAL('processExited()'),self.scrollToTop)

	if not self.proc.start():
	   QMessageBox.critical(None,'Fatal error','Could not start the uic command.','Quit')
	   exit(-1)

    def readFromStdout(self):
	self.output.append(str(self.proc.readStdout()))

    def scrollToTop(self):
	self.output.setContentsPos(0,0)

## main program
a = QApplication( sys.argv )

manager = UicManager()
a.setMainWidget(manager)
manager.setCaption('process')
manager.show()

a.exec_loop()
