#!/usr/bin/env python

import sys
from qt import *

TRUE  = 1
FALSE = 0

class RangeControls( QVBox ):
    def __init__(self,parent=None,name=None):
	QVBox.__init__(self,parent,name)

	self.row1 = QHBox(self)

	self.cell2 = QVBox(self.row1)
	self.cell2.setMargin(10)
	self.cell2.setFrameStyle(QFrame.WinPanel|QFrame.Sunken)

	QWidget(self.cell2)

	label1 = QLabel(QString("Enter a value between\n%1 and %2:").arg(-2147483647).arg(2147483647),self.cell2)
	label1.setMaximumHeight(label1.sizeHint().height())
	self.sb1 = QSpinBox(-2147483647,2147483647,1,self.cell2)
	self.sb1.setValue(0)

	label2 = QLabel("Entera zoom value:",self.cell2)
	label2.setMaximumHeight(label2.sizeHint().height())
	self.sb2 = QSpinBox(0,1000,10,self.cell2)
	self.sb2.setSuffix("%")
	self.sb2.setSpecialValueText("Automatic")

	label3 = QLabel("Enter a price:",self.cell2)
	label3.setMaximumHeight(label3.sizeHint().height())
	self.sb3 = QSpinBox(0,2147483647,1,self.cell2)
	self.sb3.setPrefix("$")
	self.sb3.setValue(355)

	QWidget(self.cell2)

	self.row2 = QHBox(self)
	self.cell3 = QVBox(self.row2)
	self.cell3.setMargin(10)
	self.cell3.setFrameStyle(QFrame.WinPanel|QFrame.Sunken)
	self.hslider = QSlider(0,64,1,33,Qt.Horizontal,self.cell3,"horizontal_s")
	self.lcd2 = QLCDNumber(2,self.cell3)
	self.lcd2.display(33)
	self.lcd2.setSegmentStyle(QLCDNumber.Filled)
	self.connect(self.hslider,SIGNAL('valueChanged(int)'),self.lcd2,SLOT('display(int)'))

	self.cell4 = QHBox(self.row2)
	self.cell4.setFrameStyle(QFrame.WinPanel|QFrame.Sunken)
	self.cell4.setMargin(10)
	self.vslider = QSlider(0,64,1,8,Qt.Vertical,self.cell4)
	self.lcd3 = QLCDNumber(3,self.cell4)
	self.lcd3.display(8)
	self.connect(self.vslider,SIGNAL('valueChanged(int)'),self.lcd3,SLOT('display(int)'))


## main program
a = QApplication(sys.argv)

rc = RangeControls()
rc.resize(500,300)
rc.setCaption("PyQT Example - Range Control Widgets")
a.setMainWidget(rc)
rc.show()

a.exec_loop()

