#!/usr/bin/env python

import sys
from qt import *

TRUE  = 1
FALSE = 0

class MyRichText( QVBox ):
    def __init__(self,parent=None,name=None):
	QVBox.__init__(self,parent,name)

	self.sayings = [
	
	"<b>Saying 1:</b><br>"
	"<hr><br><br>"
	"<big>Evil is that which one believes of others.  It is a sin to believe evil "
	"of others, but it is seldom a mistake.</big><br><br>"
	"<center><i>-- H.L. Mencken</i></center>",

	"<b>Saying 2:</b><br>"
	"<hr><br><br>"
	"<big>A well-used door needs no oil on its hinges.<br>"
	"A swift-flowing steam does not grow stagnant.<br>"
	"Neither sound nor thoughts can travel through a vacuum.<br>"
	"Software rots if not used.<br><br>"
	"These are great mysteries.</big><br><br>"
	"<center><i>-- Geoffrey James, \"The Tao of Programming\"</i></center>",

	"<b>Saying 3:</b><br>"
	"<hr><br><br>"
	"<big>Show business is just like high school, except you get paid.</big><br><br>"
	"<center><i>-- Martin Mull</i></center>",

	"<b>Saying 4:</b><br>"
	"<hr><br><br>"
	"<big><b>The Least Successful Executions</b><br>"
	"<twocolumn><p>      History has furnished us with two executioners worthy of attention. "
	"The first performed in Sydney in Australia.  In 1803 three attempts were "
	"made to hang a Mr. Joseph Samuels.  On the first two of these the rope "
	"snapped, while on the third Mr. Samuels just hung there peacefully until he "
	"and everyone else got bored.  Since he had proved unsusceptible to capital "
	"punishment, he was reprieved.</p>"
	"<p>        The most important British executioner was Mr. James Berry who "
	"tried three times in 1885 to hang Mr. John Lee at Exeter Jail, but on each "
	"occasion failed to get the trap door open.<!p>"
	"<p>        In recognition of this achievement, the Home Secretary commuted "
	"Lee's sentence to \"life\" imprisonment.  He was released in 1917, emigrated "
	"to America and lived until 1933.</p></twocolumn></big><br><br>"
	"<center><i>-- Stephen Pile, \"The Book of Heroic Failures\"</i></center>",

	"<b>Saying 5:</b><br>"
	"<hr><br><br>"
	"<big>If you can, help others.  If you can't, at least don't hurt others.</big><br><br>"
	"<center><i>-- the Dalai Lama</i></center>",

	"<b>Saying 6:</b><br>"
	"<hr><br><br>"
	"<big>Television has brought back murder into the home -- where it belongs.</big><br><br>"
	"<center><i>-- Alfred Hitchcock</i></center>",

	"<b>Saying 7:</b><br>"
	"<hr><br><br>"
	"<big>I don't know who my grandfather was; I am much more concerned to know "
	"what his grandson will be.</big><br><br>"
	"<center><i>-- Abraham Lincoln</i></center>",

	0]

	self.setMargin(5)
	
	self.view = QTextView(self)
	self.view.setText("This is a <b>Test</b> with <i>italic</i> <u>stuff</u>")
	self.paper = QBrush()
	self.paper.setPixmap(QPixmap("marble.png"))
	if self.paper.pixmap() != 0:
		self.view.setPaper(self.paper)
	else:
		self.view.setPaper(Qt.white)

	self.view.setText(self.sayings[0])
	self.view.setMinimumSize(450,250)

	self.buttons = QHBox(self)
	self.buttons.setMargin(5)

	self.bClose = QPushButton("&Close",self.buttons)
	self.bPrev = QPushButton("<< &Prev",self.buttons)
	self.bNext = QPushButton("&Next >>",self.buttons)

	self.bPrev.setEnabled(FALSE)

	self.connect(self.bClose,SIGNAL('clicked()'),qApp,SLOT('quit()'))
	self.connect(self.bPrev,SIGNAL('clicked()'),self.prev)
	self.connect(self.bNext,SIGNAL('clicked()'),self.next)

	self.num = 0


    def prev(self):
	if self.num <= 0:
		return
	self.num = self.num - 1

	self.view.setText(self.sayings[self.num])

	if self.num == 0:
		self.bPrev.setEnabled(FALSE)

	self.bNext.setEnabled(TRUE)


    def next(self):
	self.num = self.num + 1

	if self.sayings[self.num] == 0:
		return

	self.view.setText(self.sayings[self.num])
	
	if self.sayings[self.num + 1] == 0:
		self.bNext.setEnabled(FALSE)

	self.bPrev.setEnabled(TRUE)


## main program
a = QApplication(sys.argv)

richtext = MyRichText()
richtext.resize(450,350)
richtext.setCaption("PyQT Example - Richtext")
a.setMainWidget(richtext)
richtext.show()

a.exec_loop()
