#!/usr/bin/env python

import sys
from qt import *
from string import *
from struct import *

TRUE  = 1
FALSE = 0

class Rot13( QWidget ):
    def __init__( self, *args ):
    	apply( QWidget.__init__, (self,) + args )
    	self.left = QMultiLineEdit(self,"left")
    	self.right = QMultiLineEdit(self,"right")
    	self.connect(self.left,SIGNAL('textChanged()'),self.changeRight)
    	self.connect(self.right,SIGNAL('textChanged()'),self.changeLeft)
    

    	quit = QPushButton("&Quit",self)
    	self.connect(quit,SIGNAL('clicked()'),qApp,SLOT('quit()'))
    
    	l = QGridLayout(self,2,2,5)
    	l.addWidget(self.left,0,0)
    	l.addWidget(self.right,0,1)
    	l.addWidget(quit,1,1,QWidget.AlignRight)
    
    	self.left.setFocus()

    def changeLeft(self):
    	self.left.blockSignals(TRUE)
    	self.left.setText(self.rot13(self.right.text()))
    	self.left.blockSignals(FALSE)

    def changeRight(self):
    	self.right.blockSignals(TRUE)
    	self.right.setText(self.rot13(self.left.text()))
    	self.right.blockSignals(FALSE)

    def rot13(self,input):
    	r = str(input)
    	i = input.length()
    	while i:
    	    i = i-1
    	    if r[i] >= 'A' and r[i] <= 'M' or r[i] >= 'a' and r[i] <= 'm':
    	        k = unpack('B',r[i])[0]
    	        temp = k + 13
    	        s = pack('B',temp)
    	        r = r[:i]+s[0]+r[i+1:]
            elif r[i] >= 'N' and r[i] <= 'Z' or r[i] >= 'n' and r[i] <= 'z':
                k = unpack('B',r[i])[0]
                temp = k - 13
                s = pack('B',temp)
                r = r[:i]+s[0]+r[i+1:]
    	return r

## main program
a = QApplication(sys.argv)

r = Rot13()
r.resize(400,400)
r.setCaption("PyQT Example - ROT13")
a.setMainWidget(r)
r.show()

a.exec_loop()