#!/usr/bin/env python

import sys
from qt import *

TRUE  = 1
FALSE = 0

class Test( QWidget ):
    def __init__(self,parent=None,name=None):
        QWidget.__init__(self,parent,name)
	
    def paintEvent(self,e):
	p = QPainter(self)
	p.setClipRect(e.rect())
	d = 1000
	x1 = 0
	x2 = self.width() - 1
	y1 = 0
	y2 = self.height() - 1

	x = (x1 + x2)/2
	p.drawLine(x,y1,x+d,y1+d)
	p.drawLine(x,y1,x-d,y1+d)
	p.drawLine(x,y2,x+d,y2-d)
	p.drawLine(x,y2,x-d,y2-d)

	y = (y1 + y2)/2
	p.drawLine(x1,y,x1+d,y+d)
	p.drawLine(x1,y,x1+d,y-d)
	p.drawLine(x2,y,x2-d,y+d)
	p.drawLine(x2,y,x2-d,y-d)


## main program
a = QApplication(sys.argv)

s1 = QSplitter(QSplitter.Vertical,None,'main')

s2 = QSplitter(QSplitter.Horizontal,s1,'top')

t1 = Test(s2,'topLeft')
t1.setPaletteBackgroundColor(QColor(Qt.blue.light(180)))
t1.setMinimumSize(50,0)

t2 = Test(s2,'topRight')
t2. setPaletteBackgroundColor(QColor(Qt.green.light(180)))
s2.setResizeMode(t2,QSplitter.KeepSize)
s2.moveToFirst(t2)

s3 = QSplitter(QSplitter.Horizontal,s1,'bottom')

t3 = Test(s3,'bottomLeft')
t3. setPaletteBackgroundColor(Qt.red)
t4 = Test(s3,'bottomMiddle')
t4. setPaletteBackgroundColor(Qt.white)

t5 = Test(s3,'bottomRight')
t5.setMaximumHeight(250)
t5.setMinimumSize(80,50)
t5. setPaletteBackgroundColor(Qt.yellow)

s2.setOpaqueResize(TRUE)
s3.setOpaqueResize(TRUE)

a.setMainWidget(s1)
s1.setCaption("PyQT Example - Splitter")
s1.show()

result = a.exec_loop()


