#!/usr/bin/env python

import sys, string
from qt import *

TRUE  = 1
FALSE = 0
class TabDialog( QTabDialog ):
    def __init__( self,parent=None,name=None):
        QTabDialog.__init__(self,parent,name) 

	self.fileinfo = QFileInfo()
	self.filename = '.'

	self.setupTab1()
	self.setupTab2()
	self.setupTab3()

    def setupTab1(self):
	tab1 = QVBox(self)
	tab1.setMargin(5)
	QLabel('Filename',tab1)
	fname = QLineEdit(self.filename,tab1)
	fname.setFocus()

	QLabel('Path:',tab1)
	self.path = QLabel(self.fileinfo.dirPath(TRUE),tab1)
	self.path.setFrameStyle(QFrame.Panel|QFrame.Sunken)	

	QLabel('Size:',tab1)
	kb = self.fileinfo.size()/1024
	self.size = QLabel(QString('%1 KB').arg(kb),tab1)
	self.size.setFrameStyle(QFrame.Panel|QFrame.Sunken)		

	QLabel('Last Read:',tab1)
	self.lread = QLabel(self.fileinfo.lastRead().toString(),tab1)
	self.lread.setFrameStyle(QFrame.Panel|QFrame.Sunken)

	QLabel('Last Modified:',tab1)
	self.lmodif = QLabel(self.fileinfo.lastModified().toString(),tab1)
	self.lmodif.setFrameStyle(QFrame.Panel|QFrame.Sunken)

	self.addTab(tab1,'General')

    def setupTab2(self):
	tab2 = QVBox(self)
	tab2.setMargin(5)	
	bg = QButtonGroup(1,QGroupBox.Horizontal,'Permissions',tab2)

	readable = QCheckBox('Readable',bg)
	if self.fileinfo.isReadable():readable.setChecked(TRUE)

	writable = QCheckBox('Writable',bg)
	if self.fileinfo.isWritable():writable.setChecked(TRUE)

	executable = QCheckBox('Executable',bg)
	if self.fileinfo.isExecutable():executable.setChecked(TRUE)

	bg2 = QButtonGroup(2,QGroupBox.Horizontal,'Owner',tab2)
	
	QLabel('Owner',bg2)
	owner = QLabel(self.fileinfo.owner(),bg2)
	owner.setFrameStyle(QFrame.Panel|QFrame.Sunken)

	QLabel('Group',bg2)
	group = QLabel(self.fileinfo.group(),bg2)
	group.setFrameStyle(QFrame.Panel|QFrame.Sunken)

	self.addTab(tab2,'Permissions')

    def setupTab3(self):
	tab3 = QVBox(self)
	tab3.setMargin(5)
	tab3.setSpacing(5)

	QLabel(QString('Open %1 with:').arg(self.filename),tab3)

	prgs = QListBox(tab3)
	for i in range(0,30):
	    prg = QString('Aplication %1').arg(i)
	    prgs.insertItem(prg)
	prgs.setCurrentItem(3)

	QCheckBox(QString('Open files with the extention "%1" always with this application').arg(self.fileinfo.extension()),tab3)

	self.addTab(tab3,'Applications')

a = QApplication( sys.argv )

tabdialog = TabDialog()
tabdialog.resize(450,350)
tabdialog.setCaption( 'PyQt example - Tabbed Dialog' )
a.setMainWidget( tabdialog )
tabdialog.show()

a.exec_loop()
