#!/usr/bin/env python

import sys
from qt import *
from random import random

TRUE  = 1
FALSE = 0

class DynamicTip(QToolTip):
    def __init__(self,parent):
        QToolTip.__init__(self,parent)

    def maybeTip(self,pos):
	if parentWidget().inherits('TellMe') != 1:
	   return

	r = QRect(parentWidget().tip(pos))
	if r.isValid() != 1:
	   return

	s = 'position: ' + r.center().x() + ', ' + r.center().y()
	tip(r,s)

class TellMe(QWidget):
    def __init__(self,parent=None,name=None):
        QWidget.__init__(self,parent,name)
	self.setMinimumSize(30,30)
	self.r1 = self.randomRect()
	self.r2 = self.randomRect()
	self.r3 = self.randomRect()

	self.t = DynamicTip(self)

	QToolTip.add(self,self.r3,'this color is called red')

    def paintEvent(self,e):
	self.p = QPainter(self)

	if e.rect().intersects(self.r1):
	   self.p.setBrush(QBrush(Qt.blue))
	   self.p.drawRect(self.r1)
	
	if e.rect().intersects(self.r2):
	   self.p.setBrush(QBrush(Qt.blue))
	   self.p.drawRect(self.r2)

	if e.rect().intersects(self.r3):
	   self.p.setBrush(QBrush(Qt.red))
	   self.p.drawRect(self.r3)

    def mousePressEvent(self,e):
	if self.r1.contains(e.pos()):
	   self.r1 = self.randomRect()
	if self.r2.contains(e.pos()):
	   self.r2 = self.randomRect()
	self.repaint()

    def resizeEvent(self,e):
	if self.rect().contains(self.r1) != 1:
	   self.r1 = self.randomRect()
	if self.rect().contains(self.r2) != 1:
	   self.r2 = self.randomRect()

    def tip(self,p):
	if self.r1.contains(p):
	   return self.r1
	elif self.r2.contains(p):
	   return self.r2
	else:
	   return QRect(0,0,-1,-1)

    def randomRect(self):
	temp = QRect(random()*1000 % (self.width() - 20),random()*1000 % (self.height() - 20),20,20)
	return temp

## main program
a = QApplication( sys.argv )

mw = TellMe()
mw.setCaption('PyQt Example - Dynamic Tool Tips')
a.setMainWidget(mw)
mw.show()

a.exec_loop()
