#!/usr/bin/env python

import sys
from qt import *

TRUE  = 1
FALSE = 0

class Wizard( QWizard ):
    def __init__(self,parent=None,name=None):
	QWizard.__init__(self,parent,name,TRUE)

	self.setupPage1()
	self.setupPage2()
	self.setupPage3()

	self.key.setFocus()	

    def setupPage1(self):
	self.page1 = QHBox(self)
	self.page1.setSpacing(8)

	info = QLabel(self.page1)
	info.setMargin(11)
	info.setPalette(QPalette(Qt.yellow))
	info.setText("Enter your personal\n"
                   "key here.\n\n"
                   "Your personal key\n"
                   "consists of 4 digits")
	info.setMaximumWidth(info.sizeHint().width())

	page = QVBox(self.page1)
	row1 = QHBox(page)

	QLabel('Key:',row1)
	
	self.key = QLineEdit(row1)
	self.key.setMaxLength(4)
	self.key.setValidator(QIntValidator(1000,9999,self.key))

	self.connect(self.key,SIGNAL('textChanged (const QString &)'),self.keyChanged)

	self.addPage(self.page1,'Personal Key')

	self.setNextEnabled(self.page1,FALSE)
	self.setHelpEnabled(self.page1,FALSE)
	

    def setupPage2(self):
	self.page2 = QHBox(self)
	self.page2.setSpacing(8)

	info = QLabel(self.page2)
	info.setMargin(11)
	info.setPalette(QPalette(Qt.yellow))
	info.setText("\n"
                   "Enter your personal\n"
                   "data here.\n\n"
                   "The required fields are\n"
                   "First Name, Last Name \n"
                   "and E-Mail.\n")
	info.setMaximumWidth(info.sizeHint().width())

	page = QVBox(self.page2)

	row1 = QHBox(page)
	row2 = QHBox(page)
	row3 = QHBox(page)
	row4 = QHBox(page)
	row5 = QHBox(page)

	label1 = QLabel(' First Name: ',row1)
	label1.setAlignment(QLabel.AlignVCenter)
	label2 = QLabel(' Last Name: ',row2)
	label2.setAlignment(QLabel.AlignVCenter)
	label3 = QLabel(' Address: ',row3)
	label3.setAlignment(QLabel.AlignVCenter)
	label4 = QLabel(' Phone Number: ',row4)
	label4.setAlignment(QLabel.AlignVCenter)
	label5 = QLabel(' E-Mail: ',row5)
	label5.setAlignment(QLabel.AlignVCenter)

	label1.setMinimumWidth(label4.sizeHint().width())
	label2.setMinimumWidth(label4.sizeHint().width())
	label3.setMinimumWidth(label4.sizeHint().width())
	label4.setMinimumWidth(label4.sizeHint().width())
	label5.setMinimumWidth(label4.sizeHint().width())

	self.firstName = QLineEdit(row1)
	self.lastName = QLineEdit(row2)
	self.address = QLineEdit(row3)
	self.phone = QLineEdit(row4)
	self.email = QLineEdit(row5)

	self.connect(self.firstName,SIGNAL('textChanged (const QString &)'),self.dataChanged)
	self.connect(self.lastName,SIGNAL('textChanged (const QString &)'),self.dataChanged)
	self.connect(self.email,SIGNAL('textChanged (const QString &)'),self.dataChanged)

	self.addPage(self.page2,'Personal Data')
	self.setHelpEnabled(self.page2,FALSE)


    def setupPage3(self):
	self.page3 = QHBox(self)
	self.page3.setSpacing(8)

	info = QLabel(self.page3)
	info.setMargin(11)
	info.setPalette(QPalette(Qt.yellow))
	info.setText("\n"
                   "Look here to see of\n"
                   "the data you entered\n"
                   "is correct. To confirm,\n"
                   "press the [Finish] button\n"
                   "else go back to correct\n"
                   "mistakes.")
	info.setMaximumWidth(info.sizeHint().width())	

	page = QVBox(self.page3)

	row1 = QHBox(page)
	row2 = QHBox(page)
	row3 = QHBox(page)
	row4 = QHBox(page)
	row5 = QHBox(page)
	row6 = QHBox(page)

	label1 = QLabel(' Personal Key: : ',row1)
	label1.setAlignment(QLabel.AlignVCenter)
	label2 = QLabel(' First Name: ',row2)
	label2.setAlignment(QLabel.AlignVCenter)
	label3 = QLabel(' Last Name: ',row3)
	label3.setAlignment(QLabel.AlignVCenter)
	label4 = QLabel(' Address: ',row4)
	label4.setAlignment(QLabel.AlignVCenter)
	label5 = QLabel(' Phone Number: ',row5)
	label5.setAlignment(QLabel.AlignVCenter)
	label6 = QLabel(' E-Mail: ',row6)
	label6.setAlignment(QLabel.AlignVCenter)

	label1.setMinimumWidth(label1.sizeHint().width())
	label2.setMinimumWidth(label1.sizeHint().width())
	label3.setMinimumWidth(label1.sizeHint().width())
	label4.setMinimumWidth(label1.sizeHint().width())
	label5.setMinimumWidth(label1.sizeHint().width())
	label6.setMinimumWidth(label1.sizeHint().width())

	self.lKey = QLabel(row1)
	self.lFirstName = QLabel(row2)
	self.lLastName = QLabel(row3)
	self.lAddress = QLabel(row4)
	self.lPhone = QLabel(row5)
	self.lEmail = QLabel(row6)

	self.addPage(self.page3,'Finish')

	self.setFinishEnabled(self.page3,TRUE)
	self.setHelpEnabled(self.page3,FALSE)

    def showPage(self,page):
	if page == self.page1:pass
	elif page == self.page2:pass
	elif page == self.page3:
	     self.lKey.setText(self.key.text())
	     self.lFirstName.setText(self.firstName.text())
	     self.lLastName.setText(self.lastName.text())
	     self.lAddress.setText(self.address.text())
	     self.lPhone.setText(self.phone.text())
	     self.lEmail.setText(self.email.text())

	QWizard.showPage(self,page)
	if page == self.page1:
	   self.keyChanged(self.key.text())
	   self.key.setFocus()
	elif page == self.page2:
	   self.dataChanged(self.firstName.text())
	   self.firstName.setFocus()
	elif page == self.page3:
	   self.finishButton().setEnabled(TRUE)
	   self.finishButton().setFocus()

    def keyChanged(self,text):
	t = text
	p = 0
	if (self.key.validator().validate(t,p)[0] == QValidator.Acceptable):
	   on = TRUE
	else:
	   on = FALSE
	self.nextButton().setEnabled(on)

    def dataChanged(self,text):
	if ((self.firstName.text().isEmpty() != 1)and(self.lastName.text().isEmpty() != 1)and(self.email.text().isEmpty() != 1)):
	       self.nextButton().setEnabled(TRUE)
	else:
	   self.nextButton().setEnabled(FALSE)

## main program
a = QApplication(sys.argv)

wizard = Wizard()
wizard.setCaption("PyQT Example - Wizard")

wizard.exec_loop()

