#!/bin/sh

if test `id -u` != "0"; then
    echo "You aren't root, sorry..."
    exit 1
fi

prefix=/usr/local/ba

mkdir -p /usr
mkdir -p /usr/local
mkdir -p /usr/local/ba

list=`du -a | grep -v install.sh | awk '{ print $2 }' | grep -v '^\.$' | sort`

for d in $list
do
    if test -d $d; then
	d1=`echo $d | sed 's/\.\///'`
	echo $d1
	mkdir -p $prefix/$d1
    fi
done

for f in $list
do
    if test -f $f; then
	f1=`echo $f | sed 's/\.\///'`
	d1=`echo $f1 | sed 's/\/[^\/]\+$//'`
	ext=`echo $f1 | sed 's/^.\+\.//'`

	if test "$ext" = "app"; then
	    echo $f1
	    install -m 755 -o 0 -g 0 $f1 $prefix/$d1
	elif test "$ext" = "6"; then
	    echo $f1
	    install -m 755 -o 0 -g 0 $f1 $prefix/$d1
	else
	    install -m 644 -o 0 -g 0 $f1 $prefix/$d1
	fi
    fi
done

install -m 755 bin/ba /usr/bin/ba

mkdir -p /usr
mkdir -p /usr/local
mkdir -p /usr/local/thekompany
mkdir -p /usr/local/thekompany/plugins
mkdir -p /usr/local/thekompany/plugins/designer

for f in plugins/designer/*
do
    install -m 755 -o 0 -g 0 $f /usr/local/thekompany/plugins/designer
done
